@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@using Microsoft.AspNetCore.Components.Forms
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@implements IDisposable

<Row>
  <Column>
    <Field Horizontal="true">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is3.OnDesktop">@Localize["from"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is9.OnDesktop">
        <Addons>
          <Addon AddonType="AddonType.Body">
            <DateEdit TValue="DateTime?" @bind-Date="SD.Filters.DateFromFilter"></DateEdit>
          </Addon>
          <Addon AddonType="AddonType.End">
            <Button Clicked="@((e)=>{SD.Filters.DateFromFilter=null;})"><Icon Name="IconName.Clear" /></Button>
          </Addon>
        </Addons>
      </FieldBody>
    </Field>
  </Column>
</Row>
<Row>
  <Column>
    <Field Horizontal="true">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is3.OnDesktop">@Localize["to"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is9.OnDesktop">
        <Addons>
          <Addon AddonType="AddonType.Body">
            <DateEdit TValue="DateTime?" @bind-Date="SD.Filters.DateToFilter"></DateEdit>
          </Addon>
          <Addon AddonType="AddonType.End">
            <Button Clicked="@((e)=>{SD.Filters.DateToFilter=null;})"><Icon Name="IconName.Clear" /></Button>
          </Addon>
        </Addons>
      </FieldBody>
    </Field>
  </Column>
</Row>

@code {

  protected override void OnInitialized() {
    SD.Filters.FilterChanged += this.FilterChanged;
  }

  private void FilterChanged(object sender, EventArgs e) {
    this.InvokeAsync(() => this.StateHasChanged());
  }

  public void Dispose() {
    SD.Filters.FilterChanged -= this.FilterChanged;
  }
}
